;; m3/theme.jl

;; based on minimal by Garcia Galego <rgarcia@eurielec.etsit.upm.es>
;; hacked up a bit by Jacob Berkman <jacob@helixcode.com>

(let* (

(title-width
  (lambda (w)
  (let
      ((w-width (car (window-dimensions w))))
    (max 0 (text-width (window-name w))))))

  (update-text-width
     (lambda (w)
      (if (eq (window-get w 'current-frame-style) 'm3)
          (rebuild-frame w))))

  (font (get-font "-misc-fixed-medium-r-normal-*-*-100-*-*-c-*-iso8859-1"))

  (font-colors (list (get-color "black")    (get-color "black")))
  (colors      (list (get-color "darkgrey") (get-color "grey")))
  (pre-colors  (list (get-color "darkgrey") (get-color "white")))
  (post-colors (list (get-color "darkgrey") (get-color "black")))
  (mid-colors  (list (get-color "darkgrey") (get-color "darkgrey")))

(frame
 `(
   ;; Bar
   ((background . ,colors)
    (foreground . ,font-colors)
    (font . ,font)
    (text . ,window-name)
    (top-edge . 1)
    (height . 10)
    (right-edge . 12)
    (width . ,(lambda (w) (title-width w)))
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; Separator
   ((background . ,mid-colors)
    (top-edge . 0)
    (right-edge . 11)
    (height . 12)
    (width . 1)
    (class menu-button))

   ;; Other frame borders...
   ((background . ,pre-colors)
    (top-edge . 0)
    (right-edge . 0)
    (height . 1)
    (width . ,(lambda (w) (+ (title-width w) 12))))

   ((background . ,post-colors)
    (top-edge . 11)
    (right-edge . 0)
    (height . 1)
    (width . ,(lambda (w) (+ (title-width w) 12))))

   ((background . ,post-colors)
    (right-edge . 0)
    (top-edge . 0)
    (width . 1)
    (height . 12))

   ((background . ,pre-colors)
    (top-edge . 0)
    (right-edge . ,(lambda (w) (+ (title-width w) 12)))
    (width . 1)
    (height . 12))

   ;; Button
   ((background . ,colors)
    (top-edge . 1)
    (right-edge . 1)
    (height . 10)
    (width . 10)
    (class . menu-button)))))


  (add-frame-style 'm3
                   (lambda (w type) 
                     (cond ((eq type 'unframed)
                            nil-frame)
                           (t
                            frame))))

 (call-after-property-changed 'WM_NAME update-text-width))
